Index: trunk/tools/Controller/DualShock3/src/DualShock3.cpp
===================================================================
--- trunk/tools/Controller/DualShock3/src/DualShock3.cpp	(revision 122)
+++ trunk/tools/Controller/DualShock3/src/DualShock3.cpp	(revision 137)
@@ -79,9 +79,9 @@
 namespace sensor {
 
-DualShock3::DualShock3(const FrameworkManager *parent, string name,
+DualShock3::DualShock3(string name,
                        string receiverAddress, int receiverPort,
                        ConnectionType_t _connectionType, uint32_t period,
                        uint32_t bitsPerAxis, uint8_t priority)
-    : HostEthController(parent, name, receiverAddress, receiverPort, period,
+    : HostEthController(name, receiverAddress, receiverPort, period,
                         bitsPerAxis, priority),
       connectionType(_connectionType) {
Index: trunk/tools/Controller/DualShock3/src/DualShock3.h
===================================================================
--- trunk/tools/Controller/DualShock3/src/DualShock3.h	(revision 122)
+++ trunk/tools/Controller/DualShock3/src/DualShock3.h	(revision 137)
@@ -52,5 +52,5 @@
   typedef enum { Usb, Bluetooth } ConnectionType_t;
 
-  DualShock3(const core::FrameworkManager *parent, std::string name,
+  DualShock3(std::string name,
              std::string receiverAddress, int receiverPort,
              ConnectionType_t connectionType, uint32_t period = 10,
Index: trunk/tools/Controller/DualShock3/src/main.cpp
===================================================================
--- trunk/tools/Controller/DualShock3/src/main.cpp	(revision 122)
+++ trunk/tools/Controller/DualShock3/src/main.cpp	(revision 137)
@@ -47,8 +47,8 @@
   if (connection == "usb") {
     //        manager->Warn("!! adresse = %s !!\n", address.c_str());
-    joystick = new DualShock3(manager, "dualshock3", receiverAddress,
+    joystick = new DualShock3("dualshock3", receiverAddress,
                               receiverPort, DualShock3::Usb, period, 6);
   } else {
-    joystick = new DualShock3(manager, "dualshock3", receiverAddress,
+    joystick = new DualShock3("dualshock3", receiverAddress,
                               receiverPort, DualShock3::Bluetooth, period, 6);
   }
Index: trunk/tools/Controller/Mavlink/src/Forwarder.cpp
===================================================================
--- trunk/tools/Controller/Mavlink/src/Forwarder.cpp	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/Forwarder.cpp	(revision 137)
@@ -28,7 +28,7 @@
 using namespace flair::core;
 
-Forwarder::Forwarder(const FrameworkManager *parent, string name, string &inputAddress,
+Forwarder::Forwarder(string name, string &inputAddress,
 					 int inputPort, string &outputAddress, int outputPort):
-					 Thread(parent, name, 6), inputAddress(inputAddress), 
+					 Thread(getFrameworkManager(), name, 6), inputAddress(inputAddress), 
 					 inputPort(inputPort), outputAddress(outputAddress),
 					 outputPort(outputPort) {
Index: trunk/tools/Controller/Mavlink/src/Forwarder.h
===================================================================
--- trunk/tools/Controller/Mavlink/src/Forwarder.h	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/Forwarder.h	(revision 137)
@@ -25,5 +25,4 @@
 namespace flair {
 namespace core {
-  class FrameworkManager;
   class Socket;
 }
@@ -33,5 +32,5 @@
 public:
 
-  Forwarder(const flair::core::FrameworkManager *parent, std::string name,
+  Forwarder(std::string name,
   			std::string &inputAddress, int inputPort,
   			std::string &outputAddress, int outputPort);
Index: trunk/tools/Controller/Mavlink/src/GuiFlair.cpp
===================================================================
--- trunk/tools/Controller/Mavlink/src/GuiFlair.cpp	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/GuiFlair.cpp	(revision 137)
@@ -20,5 +20,4 @@
 #include "GuiInterface.h"
 
-#include <FrameworkManager.h>
 #include <Socket.h>
 
@@ -31,6 +30,6 @@
 using namespace flair::gui;
 
-GuiFlair::GuiFlair(const FrameworkManager *parent, string name):
-				   GuiInterface(parent, name) {
+GuiFlair::GuiFlair(string name):
+				   GuiInterface(name) {
 	cout << "MavPlanner GuiFlair constructor" << endl;
 
Index: trunk/tools/Controller/Mavlink/src/GuiFlair.h
===================================================================
--- trunk/tools/Controller/Mavlink/src/GuiFlair.h	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/GuiFlair.h	(revision 137)
@@ -26,5 +26,4 @@
 namespace flair {
 namespace core {
-  class FrameworkManager;
   class Socket;
 }
@@ -34,5 +33,5 @@
 public:
 
-  GuiFlair(const flair::core::FrameworkManager *parent, std::string name);
+  GuiFlair(std::string name);
   ~GuiFlair();
 
Index: trunk/tools/Controller/Mavlink/src/GuiGcs.cpp
===================================================================
--- trunk/tools/Controller/Mavlink/src/GuiGcs.cpp	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/GuiGcs.cpp	(revision 137)
@@ -21,5 +21,4 @@
 
 #include <Socket.h>
-#include <FrameworkManager.h>
 
 #include "MavlinkUDP.h"
@@ -36,7 +35,7 @@
 const std::string delimiter = "|";
 
-GuiGcs::GuiGcs(const FrameworkManager *parent, string name,
+GuiGcs::GuiGcs(string name,
   		 	   std::string &outputAddress, int outputPort):
-			   GuiInterface(parent, name) {
+			   GuiInterface(name) {
   cout << "MavPlanner GuiGcs constructor" << endl;
   //outputSocket = new Socket((Thread *)this, "output socket", outputAddress + ":" + to_string(outputPort));
Index: trunk/tools/Controller/Mavlink/src/GuiGcs.h
===================================================================
--- trunk/tools/Controller/Mavlink/src/GuiGcs.h	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/GuiGcs.h	(revision 137)
@@ -32,5 +32,4 @@
 namespace flair {
 namespace core {
-  class FrameworkManager;
   class Socket;
 }
@@ -40,5 +39,5 @@
 public:
 
-  GuiGcs(const flair::core::FrameworkManager *parent, std::string name,
+  GuiGcs(std::string name,
   		 std::string &outputAddress, int outputPort);
   ~GuiGcs();
Index: trunk/tools/Controller/Mavlink/src/GuiInterface.cpp
===================================================================
--- trunk/tools/Controller/Mavlink/src/GuiInterface.cpp	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/GuiInterface.cpp	(revision 137)
@@ -39,7 +39,7 @@
 using namespace std;
 
-GuiInterface::GuiInterface(const FrameworkManager *parent, string name)
-                  : Thread(parent, name, 6),
-                  mainTab(new Tab(parent->GetTabWidget(), name)) {
+GuiInterface::GuiInterface(string name)
+                  : Thread(getFrameworkManager(), name, 6),
+                  mainTab(new Tab(getFrameworkManager()->GetTabWidget(), name)) {
 
   tabWidget = new TabWidget(mainTab->NewRow(), name);
Index: trunk/tools/Controller/Mavlink/src/GuiInterface.h
===================================================================
--- trunk/tools/Controller/Mavlink/src/GuiInterface.h	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/GuiInterface.h	(revision 137)
@@ -24,5 +24,4 @@
 namespace flair {
 namespace core {
-  class FrameworkManager;
   class Socket;
 }
@@ -42,5 +41,5 @@
 public:
 
-  GuiInterface(const flair::core::FrameworkManager *parent, std::string name);
+  GuiInterface(std::string name);
   ~GuiInterface();
 
Index: trunk/tools/Controller/Mavlink/src/main.cpp
===================================================================
--- trunk/tools/Controller/Mavlink/src/main.cpp	(revision 122)
+++ trunk/tools/Controller/Mavlink/src/main.cpp	(revision 137)
@@ -56,5 +56,5 @@
 
   if(mode == "forward") {
-    Forwarder *guiForwarder = new Forwarder(manager, "Forwarder",
+    Forwarder *guiForwarder = new Forwarder("Forwarder",
                                            inputAddress, inputPort,
                                            outputAddress, outputPort);
@@ -66,7 +66,7 @@
     GuiInterface *guiHandler;
     if(mode == "flair") {
-      guiHandler = new GuiFlair(manager, "GuiFlair");
+      guiHandler = new GuiFlair("GuiFlair");
     } else if (mode == "gcs") {
-      guiHandler = new GuiGcs(manager, "GuiGcs", outputAddress, outputPort);
+      guiHandler = new GuiGcs("GuiGcs", outputAddress, outputPort);
     } else {
       //ERROR